"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _AsyncQueue_elements, _AsyncQueue_waiting;
Object.defineProperty(exports, "__esModule", { value: true });
class AsyncQueue {
    constructor() {
        _AsyncQueue_elements.set(this, []);
        _AsyncQueue_waiting.set(this, []);
    }
    get size() {
        return __classPrivateFieldGet(this, _AsyncQueue_elements, "f").length;
    }
    enqueue(el) {
        const next = __classPrivateFieldGet(this, _AsyncQueue_waiting, "f").shift();
        if (next) {
            next(el);
        }
        else {
            __classPrivateFieldGet(this, _AsyncQueue_elements, "f").push(el);
        }
    }
    dequeue() {
        return __awaiter(this, void 0, void 0, function* () {
            const next = __classPrivateFieldGet(this, _AsyncQueue_elements, "f").shift();
            if (next) {
                return next;
            }
            const defer = new Promise((res) => __classPrivateFieldGet(this, _AsyncQueue_waiting, "f").push(res));
            return defer;
        });
    }
}
exports.default = AsyncQueue;
_AsyncQueue_elements = new WeakMap(), _AsyncQueue_waiting = new WeakMap();
